
(defvar yank-from-kill-ring-history nil)
(defun yank-from-kill-ring (string)
  "Insert the kill-ring item selected from the minibuffer history.
Use minibuffer navigation and search commands to browse the kill-ring
in the minibuffer history before typing RET to insert the item."
  (interactive
   (list (let ((history-add-new-input nil)
	       ;; Remove keymaps from text properties of copied string,
	       ;; because typing RET in the minibuffer might call
	       ;; an irrelevant command from the map of copied string.
	       (yank-from-kill-ring-history
                (mapcar (lambda (h)
			  (remove-list-of-text-properties
			   0 (length h)
			   '(keymap local-map action mouse-action) h)
			  h)
			kill-ring)))
	   (read-string "Yank from kill-ring: " nil 'yank-from-kill-ring-history))))
  (setq yank-window-start (window-start))
  (push-mark)
  (insert-for-yank string))

(global-set-key "\M-\C-y" 'yank-from-kill-ring)

(put 'yank-from-kill-ring 'delete-selection t)
